package net.wuenschenswert.intransparent;

import org.doit.muffin.*;

import java.awt.*;

/**
 * net.wuenschenswert.intransparent.GifTransKiller
 */
public class GifTransKiller implements FilterFactory
{
    FilterManager manager;
    Prefs prefs;
    GifTransKillerFrame frame = null;
    MessageArea messages = null;
  public static final String PREF_COLOR = "GifTransKiller.color";

  public void setManager(FilterManager manager)
  {
      this.manager = manager;
  }

    public void setPrefs(Prefs prefs)
    {
        this.prefs = prefs;

        boolean o = prefs.getOverride();
        prefs.setOverride(false);
        prefs.putColor(PREF_COLOR, Color.BLUE);
        prefs.setOverride(o);

        messages = new MessageArea();
    }

    public Prefs getPrefs()
    {
        return prefs;
    }

    public void viewPrefs()
    {
        if (frame == null)
        {
            frame = new GifTransKillerFrame(prefs, this);
        }
        frame.setVisible(true);
    }

    public Filter createFilter()
    {
        Filter f = new GifTransKillerFilter(this);
        f.setPrefs(prefs);
        return f;
    }

    public void shutdown()
    {
        if (frame != null)
        {
            frame.dispose();
        }
    }

    void save()
    {
        manager.save(this);
    }

    void report(Request request, String message)
    {
        request.addLogEntry("GifTransKiller", message);
        messages.append(message + "\n");
    }
}
