package net.wuenschenswert.intransparent;

import org.doit.muffin.MuffinFrame;
import org.doit.muffin.Prefs;
import org.doit.muffin.HelpFrame;

import javax.swing.*;
import java.awt.event.ActionListener;
import java.awt.event.WindowListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;
import java.awt.*;

public class GifTransKillerFrame extends MuffinFrame implements ActionListener, WindowListener
{
  Prefs prefs;
  GifTransKiller parent;
  JColorChooser chooser;

  public GifTransKillerFrame(Prefs prefs, GifTransKiller parent)
  {
    super("Muffin: GifTrans Killer");

    this.prefs = prefs;
    this.parent = parent;

    Panel panel = new Panel();
    GridBagLayout layout = new GridBagLayout();
    panel.setLayout(layout);
    GridBagConstraints c;

    Color color = prefs.getColor(GifTransKiller.PREF_COLOR);
    chooser = new JColorChooser(color);

    c = new GridBagConstraints();
    c.anchor = GridBagConstraints.WEST;
    layout.setConstraints(chooser, c);
    panel.add(chooser);

    add("North", panel);

    parent.messages.setEditable(false);
    add("Center", parent.messages);

    Button b;
    Panel buttonPanel = new Panel();
    buttonPanel.setLayout(new GridLayout(1, 5));
    b = new Button("Apply");
    b.setActionCommand("doApply");
    b.addActionListener(this);
    buttonPanel.add(b);
    b = new Button("Save");
    b.setActionCommand("doSave");
    b.addActionListener(this);
    buttonPanel.add(b);
    b = new Button("Clear");
    b.setActionCommand("doClear");
    b.addActionListener(this);
    buttonPanel.add(b);
    b = new Button("Close");
    b.setActionCommand("doClose");
    b.addActionListener(this);
    buttonPanel.add(b);
    b = new Button("Help");
    b.setActionCommand("doHelp");
    b.addActionListener(this);
    buttonPanel.add(b);

    add("South", buttonPanel);

    addWindowListener(this);

    pack();
    setSize(getPreferredSize());

    show();
  }

  public void actionPerformed(ActionEvent event)
  {
    String arg = event.getActionCommand();

    if ("doApply".equals(arg))
    {
      prefs.putColor(GifTransKiller.PREF_COLOR, chooser.getColor());
    }
    else if ("doSave".equals(arg))
    {
      parent.save();
    }
    else if ("doClose".equals(arg))
    {
      setVisible(false);
    }
    else if ("doClear".equals(arg))
    {
      parent.messages.clear();
    }
    else if ("doHelp".equals(arg))
    {
      new HelpFrame("GifTransKiller");
    }
  }

  public void windowActivated(WindowEvent e)
  {
  }

  public void windowDeactivated(WindowEvent e)
  {
  }

  public void windowClosing(WindowEvent e)
  {
    setVisible(false);
  }

  public void windowClosed(WindowEvent e)
  {
  }

  public void windowIconified(WindowEvent e)
  {
  }

  public void windowDeiconified(WindowEvent e)
  {
  }

  public void windowOpened(WindowEvent e)
  {
  }
}
